'''
    QVC Live Add-on

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
'''

import sys,re,os,urllib,urllib2, json
from urllib2 import urlopen
import xbmc,xbmcgui,xbmcplugin,xbmcaddon

dlg = xbmcgui.Dialog()
addon = xbmcaddon.Addon()
addon_name = addon.getAddonInfo('name')
addon_id = addon.getAddonInfo('id')
plugin_path = xbmcaddon.Addon(id=addon_id).getAddonInfo('path')
addon_logo = xbmc.translatePath(os.path.join(plugin_path,'tvaddons_logo.png'))
main_url = "http://www.qvc.com/content/shop-live-tv.html"
json_match_string = "var oLiveStreams = (.+?);"

def find_single_match(text,pattern):
    result = ""
    try:    
        matches = re.findall(pattern,text,flags=re.DOTALL)
        result = matches[0]
    except:
        result = ""
    return result

if __name__ == '__main__':
    #TVADDONS Branding
    xbmcgui.Dialog().notification(addon_name + ' is provided by:','www.tvaddons.co',addon_logo,10000,False)

    #Get QVC json
    req = urllib2.Request(main_url)
    req.add_header('User-Agent','Mozilla/5.0 (Windows; U; Windows NT 5.1; en-GB; rv:1.9.0.3) Gecko/2008092417 Firefox/3.0.3')
    response = urllib2.urlopen(req)
    link = response.read()
    response.close()
    qvc_json = json.loads(find_single_match(link,json_match_string))

    qvc_url = qvc_json["QVC"]["url"]
    qvc2_url = qvc_json["2CH"]["url"]
    iq_url = qvc_json["STA"]["url"]
        
    #Channel Selection
    source = xbmcgui.Dialog().select("Choose Channel", ["[COLOR blue]QVC[/COLOR]","[COLOR blue]QVC2[/COLOR]","[COLOR blue]Beauty IQ[/COLOR]"])
    if source == 0:
        channel_url = qvc_url
    if source == 1:
        channel_url = qvc2_url
    if source == 2:
        channel_url = iq_url
    if source < 0:
        xbmc.executebuiltin('Activatewindow(home)')
        exit()

    #Play QVC stream depending on Channel Selection
    stream = "http:" + channel_url + "?rebase=on"
    if "m3u8" in channel_url:
        xbmc.executebuiltin('Activatewindow(home)')
        xbmc.Player().play(stream)
    else:
        dlg.ok(addon_name, "Unable to get stream. Please try again later.")
        xbmc.executebuiltin('Activatewindow(home)')
